package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.eam.core.eam_core.domain.EMEQSpare;
import cn.ibizlab.eam.core.eam_core.filter.EMEQSpareSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQSpare] 服务对象接口
 */
public interface IEMEQSpareService extends IService<EMEQSpare>{

    boolean update(EMEQSpare et) ;
    void updateBatch(List<EMEQSpare> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMEQSpare et) ;
    boolean create(EMEQSpare et) ;
    void createBatch(List<EMEQSpare> list) ;
    boolean save(EMEQSpare et) ;
    void saveBatch(List<EMEQSpare> list) ;
    EMEQSpare getDraft(EMEQSpare et) ;
    EMEQSpare get(String key) ;
    Page<EMEQSpare> searchDefault(EMEQSpareSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EMEQSpare> getEmeqspareByIds(List<String> ids) ;
    List<EMEQSpare> getEmeqspareByEntities(List<EMEQSpare> entities) ;

}


